###################################################
### chunk number 1: 
###################################################
library(tgp)
options(width=65)


###################################################
### chunk number 2: 
###################################################
library(tgp)
library(maptree)
#options(width=65)
seed <- 0; set.seed(seed)


###################################################
### chunk number 3: 
###################################################
fb.train <- fried.bool(500)
X <- fb.train[,1:13]; Z <- fb.train$Y
fb.test <- fried.bool(1000)
XX <- fb.test[,1:13]; ZZ <- fb.test$Ytrue


###################################################
### chunk number 4: 
###################################################
names(X)


###################################################
### chunk number 5: 
###################################################
fit1 <- bcart(X=X, Z=Z, XX=XX, verb=0)
rmse1 <- sqrt(mean((fit1$ZZ.mean - ZZ)^2))
rmse1


###################################################
### chunk number 6: cat-fbcart-mapt
###################################################
tgp.trees(fit1, "map")


###################################################
### chunk number 7: 
###################################################
graphics.off()


###################################################
### chunk number 8: 
###################################################
fit2 <- btlm(X=X, Z=Z, XX=XX, verb=0)
rmse2 <- sqrt(mean((fit2$ZZ.mean - ZZ)^2))
rmse2


###################################################
### chunk number 9: cat-fbtlm-trees
###################################################
tgp.trees(fit2, "map")


###################################################
### chunk number 10: 
###################################################
graphics.off()


###################################################
### chunk number 11: 
###################################################
fit3 <- btlm(X=X, Z=Z, XX=XX, basemax=10, verb=0)
rmse3 <- sqrt(mean((fit3$ZZ.mean - ZZ)^2))
rmse3


###################################################
### chunk number 12: cat-fbtlm-mapt
###################################################
tgp.trees(fit3, "map")


###################################################
### chunk number 13: 
###################################################
graphics.off()


###################################################
### chunk number 14: 
###################################################
fit4 <- btgpllm(X=X, Z=Z, XX=XX, verb=0)
rmse4 <- sqrt(mean((fit4$ZZ.mean - ZZ)^2))
rmse4


###################################################
### chunk number 15: 
###################################################
fit4$gpcs


###################################################
### chunk number 16: 
###################################################
fit5 <-  btgpllm(X=X, Z=Z, XX=XX, basemax=10, verb=0)
rmse5 <- sqrt(mean((fit5$ZZ.mean - ZZ)^2))
rmse5 


###################################################
### chunk number 17: cat-fb-mapt
###################################################
h <- fit1$post$height[which.max(fit1$posts$lpost)]
tgp.trees(fit5, "map")


###################################################
### chunk number 18: 
###################################################
graphics.off()


###################################################
### chunk number 19: 
###################################################
fit6 <-  btgpllm(X=X, Z=Z, XX=XX, basemax=10, splitmin=11, verb=0)
rmse6 <- sqrt(mean((fit6$ZZ.mean - ZZ)^2))
rmse6


###################################################
### chunk number 20: 
###################################################
library(tgp)
seed <- 0; set.seed(seed)


###################################################
### chunk number 21: 
###################################################
f <- friedman.1.data(250) 


###################################################
### chunk number 22: 
###################################################
Xf <- f[, 1:6] 
Zf <- f$Y 
sf <- sens(X=Xf, Z=Zf, nn.lhs=600, model=bgpllm, verb=0)


###################################################
### chunk number 23: 
###################################################
names(sf$sens)


###################################################
### chunk number 24: sens-full
###################################################
plot(sf, layout="sens", legendloc="topleft")


###################################################
### chunk number 25: 
###################################################
graphics.off()


###################################################
### chunk number 26: sens-mains
###################################################
par(mar=c(4,2,4,2), mfrow=c(2,3))
plot(sf, layout="sens", maineff=t(1:6))


###################################################
### chunk number 27: 
###################################################
graphics.off()


###################################################
### chunk number 28: sens-indices
###################################################
plot(sf, layout="sens", maineff=FALSE)


###################################################
### chunk number 29: 
###################################################
graphics.off()


###################################################
### chunk number 30: 
###################################################
X <- airquality[,2:4]
Z <- airquality$Ozone
rect <- t(apply(X, 2, range, na.rm=TRUE))
mode <- apply(X , 2, mean, na.rm=TRUE)
shape <- rep(2,3)


###################################################
### chunk number 31: sens-udraw
###################################################
Udraw <- lhs(300, rect=rect, mode=mode, shape=shape)
par(mfrow=c(1,3), mar=c(4,2,4,2))
for(i in 1:3){
  hist(Udraw[,i], breaks=10,xlab=names(X)[i], 
       main="",ylab="", border=grey(.9), col=8) 
}  


###################################################
### chunk number 32: 
###################################################
graphics.off()


###################################################
### chunk number 33: 
###################################################
s.air <- suppressWarnings(sens(X=X, Z=Z, nn.lhs=300, rect=rect, 
                               shape=shape, mode=mode, verb=0))


###################################################
### chunk number 34: sens-air1
###################################################
plot(s.air, layout="sens")


###################################################
### chunk number 35: 
###################################################
graphics.off()


###################################################
### chunk number 36: 
###################################################
rect[2,] <- c(0,5)
mode[2] <- 2
shape[2] <- 2


###################################################
### chunk number 37: 
###################################################
sens.p <- suppressWarnings(sens(X=X,Z=Z,nn.lhs=300, model=NULL, rect=rect, shape=shape, mode=mode))


###################################################
### chunk number 38: sens-air2
###################################################
s.air2 <- predict.tgp(s.air, BTE=c(1,1000,1), sens.p=sens.p, verb=0) 
plot(s.air2, layout="sens")


###################################################
### chunk number 39: 
###################################################
graphics.off()


###################################################
### chunk number 40: 
###################################################
X$Temp[X$Temp >70] <- 1
X$Temp[X$Temp >1] <- 0
rect <- t(apply(X, 2, range, na.rm=TRUE))
mode <- apply(X , 2, mean, na.rm=TRUE)
shape <- c(2,2,0)
s.air <- suppressWarnings(sens(X=X, Z=Z, nn.lhs=300, rect=rect, 
                               shape=shape, mode=mode, verb=0, basemax=2))


###################################################
### chunk number 41: sens-air3
###################################################
plot(s.air, layout="sens")


###################################################
### chunk number 42: 
###################################################
graphics.off()


###################################################
### chunk number 43: 
###################################################
library(tgp)
seed <- 0; set.seed(seed)


###################################################
### chunk number 44: 
###################################################
rosenbrock <- function(x){ 
  x <- matrix(x, ncol=2)
  100*(x[,1]^2 - x[,2])^2 + (x[,1] - 1)^2 
}


###################################################
### chunk number 45: 
###################################################
rosenbrock(c(1,1))


###################################################
### chunk number 46: 
###################################################
rect <- cbind(c(-1,-1),c(5,5))
X <- lhs(40, rect)
Z <- rosenbrock(X)


###################################################
### chunk number 47: 
###################################################
XX <- lhs(200, rect)
rfit <- bgp(X,Z,XX,improv=c(1,10), verb=0)


###################################################
### chunk number 48: 
###################################################
cbind(rfit$improv,XX)[rfit$improv$rank <= 10,]


###################################################
### chunk number 49: optim-fit1
###################################################
plot(rfit, as="improv")


###################################################
### chunk number 50: 
###################################################
graphics.off()


###################################################
### chunk number 51: optim-fit2
###################################################
rfit2 <- predict.tgp(rfit, XX=XX, BTE=c(1,1000,1), improv=c(5,20), verb=0) 
plot(rfit2, layout="as", as="improv")


###################################################
### chunk number 52: 
###################################################
graphics.off()


###################################################
### chunk number 53: 
###################################################
f <- function(x) { exp2d.Z(x)$Z }


###################################################
### chunk number 54: 
###################################################
rect <- rbind(c(-2,6), c(-2,6))
X <- lhs(20, rect)
Z <- f(X)


###################################################
### chunk number 55: 
###################################################
out <- progress <- NULL
for(i in 1:20) {
  
  ## get recommendations for the next point to sample
  out <- optim.step.tgp(f, X=X, Z=Z, rect=rect, prev=out, verb=0)

  ## add in the inputs, and newly sampled outputs
  X <- rbind(X, out$X)
  Z <- c(Z, f(out$X))
  
  ## keep track of progress and best optimum
  progress <- rbind(progress, out$progress)
}


###################################################
### chunk number 56: optim-progress
###################################################
par(mfrow=c(1,2))
matplot(progress[,1:2], main="x progress",
        xlab="rounds", ylab="x[,1:2]", type="l", lwd=2)
legend("topright", c("x1", "x2"), lwd=2, col=1:2, lty=1:2)
plot(log(progress$improv), type="l", main="max log improv",
     xlab="rounds", ylab="max log(improv)")


###################################################
### chunk number 57: 
###################################################
graphics.off()


###################################################
### chunk number 58: 
###################################################
out$progress[1:2]


###################################################
### chunk number 59: 
###################################################
formals(optim)$method


###################################################
### chunk number 60: 
###################################################
formals(optim.ptgpf)$method


###################################################
### chunk number 61: 
###################################################
library(tgp)
library(maptree)
#options(width=65)
seed <- 0; set.seed(seed)


###################################################
### chunk number 62: 
###################################################
geo <- default.itemps(type="geometric")
har <- default.itemps(type="harmonic")
sig <- default.itemps(type="sigmoidal")


###################################################
### chunk number 63: it-itemps
###################################################
par(mfrow=c(2,1))
all <- cbind(geo$k, har$k, sig$k)
matplot(all, pch=21:23,
        main="inv-temp ladders", xlab="indx", ylab="itemp")
legend("topright", pch=21:23, 
       c("geometric","harmonic","sigmoidal"), col=1:3)
matplot(log(all), pch=21:23,
        main="log(inv-temp) ladders", xlab="indx", ylab="itemp")


###################################################
### chunk number 64: 
###################################################
graphics.off()


###################################################
### chunk number 65: 
###################################################
ESS <- function(w)
{
  mw <- mean(w)
  cv2 <- sum((w-mw)^2)/((length(w)-1)*mw^2)
  ess <- length(w)/(1+cv2)
  return(ess)
}


###################################################
### chunk number 66: 
###################################################
exp2d.data<-exp2d.rand() 
X<-exp2d.data$X 
Z<-exp2d.data$Z 


###################################################
### chunk number 67: 
###################################################
its <- default.itemps(m=10)
exp.btlm <- btlm(X=X,Z=Z, bprior="b0", R=2, itemps=its, pred.n=FALSE,
                 BTE=c(1000,3000,2)) 


###################################################
### chunk number 68: 
###################################################
exp.btlm$ess


###################################################
### chunk number 69: 
###################################################
library(MASS)
moto.it <- btgpllm(X=mcycle[,1], Z=mcycle[,2], BTE=c(2000,52000,10),
        bprior="b0", R=3, itemps=geo, trace=TRUE, pred.n=FALSE, verb=0)


###################################################
### chunk number 70: 
###################################################
moto.it$ess$combined


###################################################
### chunk number 71: 
###################################################
p <- moto.it$trace$post
ESS(p$wlambda)


###################################################
### chunk number 72: 
###################################################
ESS(p$w)


###################################################
### chunk number 73: 
###################################################
as.numeric(c(sum(p$itemp == 1), moto.it$ess$each[1,2:3]))


###################################################
### chunk number 74: 
###################################################
moto.reg <- btgpllm(X=mcycle[,1], Z=mcycle[,2], BTE=c(2000,52000,10),
        R=3, bprior="b0", trace=TRUE, pred.n=FALSE, verb=0)


###################################################
### chunk number 75: 
###################################################
L <- length(p$height)
hw <- suppressWarnings(sample(p$height, L, prob=p$wlambda, replace=TRUE))
b <- hist2bar(cbind(moto.reg$trace$post$height, p$height, hw))


###################################################
### chunk number 76: it-moto-height
###################################################
barplot(b, beside=TRUE, col=1:3, xlab="tree height", ylab="counts", 
         main="tree heights encountered")
legend("topright", c("reg MCMC", "All Temps", "IT"), fill=1:3)


###################################################
### chunk number 77: 
###################################################
graphics.off()


###################################################
### chunk number 78: it-moto-ktrace
###################################################
plot(log(moto.it$trace$post$itemp), type="l", ylab="log(k)", xlab="samples",
     main="trace of log(k)")


###################################################
### chunk number 79: 
###################################################
graphics.off()


###################################################
### chunk number 80: it-moto-khist
###################################################
b <- itemps.barplot(moto.it, plot.it=FALSE)
barplot(t(cbind(moto.it$itemps$counts, b)), col=1:2,
        beside=TRUE, ylab="counts", xlab="itemps", 
        main="inv-temp observation counts")
legend("topleft", c("observation counts", "posterior samples"), fill=1:2)


###################################################
### chunk number 81: 
###################################################
graphics.off()


###################################################
### chunk number 82: 
###################################################
moto.it.sig <- btgpllm(X=mcycle[,1], Z=mcycle[,2], BTE=c(2000,52000,10),
                      R=3, bprior="b0", krige=FALSE, itemps=sig, verb=0)


###################################################
### chunk number 83: 
###################################################
moto.it.sig$ess$combined


###################################################
### chunk number 84: it-moto-pred
###################################################
plot(moto.it.sig)


###################################################
### chunk number 85: 
###################################################
graphics.off()


###################################################
### chunk number 86: 
###################################################
Xcand <- lhs(10000, rbind(c(-6,6),c(-6,6)))
X <- dopt.gp(400, X=NULL, Xcand)$XX
Z <- exp2d.Z(X)$Z


###################################################
### chunk number 87: 
###################################################
exp.reg <- btgpllm(X=X, Z=Z, BTE=c(2000,52000,10), bprior="b0", 
                   trace=TRUE, krige=FALSE, R=10, verb=0)


###################################################
### chunk number 88: it-exp-pred
###################################################
plot(exp.reg)


###################################################
### chunk number 89: 
###################################################
graphics.off()


###################################################
### chunk number 90: 
###################################################
h <- exp.reg$post$height[which.max(exp.reg$posts$lpost)]
h


###################################################
### chunk number 91: it-exp-mapt
###################################################
tgp.trees(exp.reg, "map")


###################################################
### chunk number 92: 
###################################################
graphics.off()


###################################################
### chunk number 93: 
###################################################
its <- default.itemps(k.min=0.02)
exp.it <- btgpllm(X=X, Z=Z, BTE=c(2000,52000,10), bprior="b0", 
               trace=TRUE, krige=FALSE, itemps=its, R=10, verb=0)


###################################################
### chunk number 94: 
###################################################
exp.it$gpcs
exp.reg$gpcs


###################################################
### chunk number 95: 
###################################################
p <- exp.it$trace$post
data.frame(ST=sum(p$itemp == 1), nIT=ESS(p$w), oIT=exp.it$ess$combined)


###################################################
### chunk number 96: 
###################################################
L <- length(p$height)
hw <- suppressWarnings(sample(p$height, L, prob=p$wlambda, replace=TRUE))
b <- hist2bar(cbind(exp.reg$trace$post$height, p$height, hw))


###################################################
### chunk number 97: it-exp-height
###################################################
barplot(b, beside=TRUE, col=1:3, xlab="tree height", ylab="counts", 
         main="tree heights encountered")
legend("topright", c("reg MCMC", "All Temps", "IT"), fill=1:3)


###################################################
### chunk number 98: 
###################################################
graphics.off()


###################################################
### chunk number 99: it-exp-trace-height
###################################################
ylim <- range(p$height, exp.reg$trace$post$height)
plot(p$height, type="l", main="trace of tree heights", 
     xlab="t", ylab="height", ylim=ylim)
lines(exp.reg$trace$post$height, col=2)
legend("topright", c("tempered", "reg MCMC"), lty=c(1,1), col=1:2)


###################################################
### chunk number 100: 
###################################################
graphics.off()


###################################################
### chunk number 101: it-expit-pred
###################################################
plot(exp.it)


###################################################
### chunk number 102: it-expit-trees
###################################################
tgp.trees(exp.it, "map")


###################################################
### chunk number 103: 
###################################################
graphics.off()


